.sh "SUGGESTIONS ON BUYING HARDWARE"
The are a variety of ways in which you can acquire the systems we
have suggested here, whether they be all DEC or mixed vendor.
Your choice of acquisition methods depends on a number of factors
including:
.IP \(bu
How much can you afford to pay?
.ns
.IP \(bu
How long can you wait?
.ns
.IP \(bu
How much risk and responsibility are you willing to assume for
integrating your own hardware components?
.ns
.IP \(bu
What kind of maintenance is available to you?
.ns
.IP \(bu
How much help you need in integrating 4BSD?
.LP
Here is a simplified breakdown of the possibilities:
.IP 1.
\fBBuy as much as possible from your DEC marketing organization.\fP
.IP
Although this solution, in our experience, takes the longest and costs
the most, it has its advantages.
DEC is likely to ship you a well tested, integrated system, close
to the time initially promised.
In most cases they will support you well through any initial start-up
problems with the hardware.
The system bought this way will automatically be accepted for a DEC
maintenance contract.
Of course, the can't help you much with 4BSD (yet).
Also, they are not likely to be very flexible about adjusting their
configuration to your needs.
.IP 2.
\fBBuy an all-DEC system from a an OEM specializing in 4BSD\fP
.IP
These OEMs are a relatively new phenomenon.
They usually get a much better discount from DEC on hardware and
can pass part of this through to you in terms of UNIX expertise
as well as reduced cost.
Sometimes they will be able to deliver hardware quickly when
DEC is telling you months.
Since they sell largely DEC systems, you can still take advantage of
DEC Field Service and most systems sold this way are guaranteed
acceptable for a DEC maintenance contract. 
.IP 3.
\fBBuy a mixed vendor system from a systems integrator\fP
.IP
DEC has had a long love/hate relationship with people
who specialize in building systems which use DEC's CPUs and other
manufacturers peripherals.
We think these integrators serve many useful functions.
First, and foremost, they often build a
cheaper and better system, frequently on short notice.
Second, they keep DEC honest.
Sometimes we feel they should charge for their quotations,
since these are often used advantageously to encourage DEC to come down
to a more reasonable price on a system.
.IP
Don't assume mixed vendor systems are not maintainable.
There is a whole spectrum of maintenance possibilities
for these systems, particularly in major metropolitan areas.
If you are considering this route, be sure and spend some time
on the phone  with the customers of your prospective vendor.
Insist on the names of \fIlong term\fP customers, and talk
a lot about maintenance experience.
The folks we mention on the last page of this paper are
known to have experience with 4BSD.
.IP 4.
\fBIntegrate the mixed vendor system yourself\fR
.IP
If you are qualified for this adventure, then you probably know
who you are.
We can't begin to tell you all the pitfalls.
Start small.  Buy a mostly integrated system and add something
you can afford to have not work for a while, such as more memory
(almost too easy), or a better tape drive, or more terminal
interfaces.
If you really want to do the whole thing, finding the CPU is
one of the harder parts.
Get yourself a copy of \fIComputer Hot Line\fP. You can probably
get a complimentary copy by calling them at (800) 247-2244.
This is the social register of computer brokers and a substantial
portion is dedicated to folks selling new and used DEC.
(Hot Line, Inc. also distributes the Farm Machinery Hot Line and
several other classified flea market variety publications.
They can not be expected to control the content of adds.
Use at your own risk!)
.LP
We would like to make two more observations
about buying equipment.
It has been our experience that the service
you will receive from your source is directly proportional
to the risk in using that source.
Further, the service often is inversely proportional
to the sources size.
Loosely translated, little guys work harder.
.LP
Many who have dealt with DEC sales report disappointing
experiences.
Lack of product knowledge and inability to bend to customer needs
are typical complaints.
This is not to say that there are not excellent DEC sales people.
There are.
And you must remember, when you finally close that deal with your
DEC salesperson, \fBit will be delivered,\fP eventually.
.LP
On the other hand, the systems integrator who builds one or
two systems a month typically succeeds or fails based of the experiences
of his small customer base.
We have known many of these folks to make superhuman efforts to pull
together a customer system, often succeeding without half the resources
available to DEC sales people.
They are also much quicker to pick up trends like an interest in 4BSD
and start to mold their services to fit.
Once again, there is always the exception, the ``Unix Systems Integrator''
who couldn't tell an inode from a tree toad.
If you go this route, you have a good selection to choose from.
\fBSpend time  talking to previous customers.\fP
