.TH COMP 1 "3 August 1983"
.UC 4
.SH NAME
comp \- compose a message
.SH SYNOPSIS
.B comp
[ \-editor editor ] [ \-form formfile ] [ file ] [ \-use ]
[ \-nouse ] [ \-help ]
.SH DESCRIPTION
\fIComp\fP is used to create a new message to be mailed.
If
\fIfile\fP is not specified, the file named \*(lqdraft\*(rq in the user's MH
directory will be used.
\fIComp\fR copies a message form to
the file being composed and then invokes an editor on the
file.
The default editor is /bin/ned, which may be overridden with
the `\-editor' switch or with a profile entry \*(lqEditor:\*(rq.
The default message form contains the following elements:
.nf

     To:
     cc:
     Subject:
     ----------

.fi
If the file named \*(lqcomponents\*(rq exists in the user's MH directory,
it will be used instead of this form.
If `\-form formfile' is specified, the specified formfile (from the MH
directory) will be used as the skeleton.
The line of dashes
or a blank line must be left between the header and the
body of the message for the message to be identified properly when it is
sent (see
.IR send (1)).
The switch `\-use' directs \fIcomp\fR to
continue editing an already started message.
That is, if a
\fIcomp\fR (or \fIdist\fR, \fIrepl\fR, or \fIforw\fR) is terminated without
sending the message, the message can be edited again via
\*(lqcomp \-use\*(rq.
.PP
If the specified file (or draft) already exists, \fIcomp\fR will ask
if you want to delete it before continuing.
A reply of \fBNo\fR will abort the
\fIcomp\fR, \fByes\fR will replace the existing draft with a blank
skeleton, \fBlist\fR will display the draft, and \fBuse\fR will use it
for further composition.
.PP
Upon exiting from the editor, \fIcomp\fR will ask \*(lqWhat now?\*(rq.
The valid
responses are \fBlist\fR, to list the draft on the terminal; \fBquit\fR, to
terminate the session and preserve the draft; \fBquit delete\fR, to terminate,
then delete the draft; \fBsend\fR, to send the message; \fBsend verbose\fR, to
cause the delivery process to be monitored; \fBedit <editor>\fR, to invoke
<editor> for further editing; and \fBedit\fR, to re-edit using the
same editor that was used on the preceding round unless a profile
entry \*(lq<lasteditor>\-next: <editor>\*(rq names an alternative editor.
.PP
\fIComp\fR does not affect either the current folder or the current message.
.SH FILES
.nf
.ta \w'or <mh-dir>/components    'u
/etc/mh/components	The message skeleton
or <mh-dir>/components	Rather than the standard skeleton
$HOME/\*.mh_profile	The user profile
<mh-dir>/draft	The default message file
/usr/new/send	To send the composed message
.fi
.SH "PROFILE COMPONENTS"
.nf
.ta \w'<lasteditor>\-next:    'u
Path:	To determine the user's MH directory
Editor:	To override the use of /bin/ned as the default editor
<lasteditor>\-next:	editor to be used after exit from <lasteditor>
.SH DEFAULTS
.nf
`file' defaults to draft
`\-editor' defaults to /bin/ned
`\-nouse'
.fi
